org.eclipse.ui.commands

## Class ExtensionParameterValues

- java.lang.Object
- - org.eclipse.ui.commands.ExtensionParameterValues

All Implemented Interfaces:
  IParameterValues, IExecutableExtension

    public final class ExtensionParameterValues
    extends Object
    implements IParameterValues, IExecutableExtension

A generic implementation of `IParameterValues` that takes advantage of the `IExecutableExtension` mechanism. The parameter values and names can be specified purely in XML. This can be done as follows:

         <command
                    name="%name"
                    description="%description"
                    categoryId="categoryId"
                    id="commandId">
                    <parameter
                            id="parameterId"
                            name="%parameterName">
                                    <values class="org.eclipse.ui.commands.ExtensionParameterValues">
                                            <parameter name="%parameterName1" value="parameterValue1" />
                                            <parameter name="%parameterName2" value="parameterValue2" />
                                            <parameter name="%parameterName3" value="parameterValue3" />
                                    </values>
              </parameter>
         </command>

Since:
  3.1

### Field Summary

Fields
`static String` `DELIMITER` The delimiter between elements if the name-value pairs are specified in a single string.

### Constructor Summary

Constructors
Constructor and Description
`ExtensionParameterValues()`

### Method Summary

All Methods Instance Methods Concrete Methods
`Map` `getParameterValues()` Returns a map keyed by externalized names for parameter values.
`void` `setInitializationData(IConfigurationElement config, String propertyName, Object data)` This method is called by the implementation of the method `IConfigurationElement.createExecutableExtension` on a newly constructed extension, passing it its relevant configuration information.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### DELIMITER

    public static final String DELIMITER

The delimiter between elements if the name-value pairs are specified in a single string.

See Also:
  Constant Field Values

### Constructor Detail

#### ExtensionParameterValues

    public ExtensionParameterValues()

### Method Detail

#### getParameterValues

    public Map getParameterValues()

Description copied from interface: `IParameterValues`
Returns a map keyed by externalized names for parameter values. These names should be human-readable, and are generally for display to the user in a user interface of some sort. The values should be actual values that will be interpreted by the handler for the command.

Specified by:
  `getParameterValues` in interface `IParameterValues`
Returns:
  A map of the externalizable name of the parameter value (`String`) to the actual value of the parameter (`String`).

#### setInitializationData

    public final void setInitializationData(IConfigurationElement config,
                                            String propertyName,
                                            Object data)

Description copied from interface: `IExecutableExtension`
This method is called by the implementation of the method `IConfigurationElement.createExecutableExtension` on a newly constructed extension, passing it its relevant configuration information. Most executable extensions only make use of the first two call arguments.

Regular executable extensions specify their Java implementation class name as an attribute of the configuration element for the extension. For example

         <action run="com.example.BaseAction"/>

In the above example, this method would be called with a reference to the `<action>` element (first argument), and `"run"` as the name of the attribute that defined this executable extension (second argument).

The last parameter is for the specific use of extension adapters and is typically not used by regular executable extensions.

There are two supported ways of associating additional adapter-specific data with the configuration in a way that is transparent to the extension point implementor:

(1) by specifying adapter data as part of the implementation class attribute value. The Java class name can be followed by a ":" separator, followed by any adapter data in string form. For example, if the extension point specifies an attribute `"run"` to contain the name of the extension implementation, an adapter can be configured as

         <action run="com.example.ExternalAdapter:./cmds/util.exe -opt 3"/>

(2) by converting the attribute used to specify the executable extension to a child element of the original configuration element, and specifying the adapter data in the form of xml markup. Using this form, the example above would become

         <action>
             <<it>run</it> class="com.xyz.ExternalAdapter">
                 <parameter name="exec" value="./cmds/util.exe"/>
                 <parameter name="opt"  value="3"/>
             </<it>run</it>>
         </action>

Form (2) will typically only be used for extension points that anticipate the majority of extensions configured into it will in fact be in the form of adapters.

In either case, the specified adapter class is instantiated using its 0-argument public constructor. The adapter data is passed as the last argument of this method. The data argument is defined as Object. It can have the following values:

- `null`, if no adapter data was supplied
- in case (1), the initialization data string is passed as a `String`
- in case (2), the initialization data is passed as a `Hashtable` containing the actual parameter names and values (both `String`s)

Specified by:
  `setInitializationData` in interface `IExecutableExtension`
Parameters:
  `config` - the configuration element used to trigger this execution. It can be queried by the executable extension for specific configuration properties
  `propertyName` - the name of an attribute of the configuration element used on the `createExecutableExtension(String)` call. This argument can be used in the cases where a single configuration element is used to define multiple executable extensions.
  `data` - adapter data in the form of a `String`, a `Hashtable`, or `null`.
See Also:
  `IConfigurationElement.createExecutableExtension(String)`